unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, GLU, GL;

type
  TForm1 = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    DC:HDC;
    hrc:HGLRC;
    procedure PixelFormat;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormPaint(Sender: TObject);
var
 ps:TPaintStruct;
 fogColor : Array[0..3] of GLfloat;
begin
 BeginPaint(Handle,ps);
 glClearColor(1,0.5,0.5,1);
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

 glRotated(45,1,0,0);

 glEnable(GL_DEPTH_TEST);
 glDepthFunc(GL_LESS);

 glEnable(GL_FOG);
 glFogi(GL_FOG_MODE,GL_EXP2);
 fogColor[0]:=1;
 fogColor[1]:=0;
 fogColor[2]:=0;

 glFogfv(GL_FOG_COLOR, @fogColor);
 glFogi(GL_FOG_DENSITY,100);
 glFogi(GL_FOG_END,10);

 glColor3f (0.0, 1.0, 0.0);
 glBegin(GL_QUAD_STRIP);
  glVertex3f(1.25,1.25,1);
  glVertex3f(1.25,-1.0,1);
  glVertex3f(-1,1.25,0);
  glVertex3f(-1,-1.0,0);
 glEnd;

 glColor3f (1.0, 1.0, 0.0);
 glBegin(GL_QUAD_STRIP);
  glVertex3f(1.0,1.0,0);
  glVertex3f(1.0,-1.25,0);
  glVertex3f(-1.25,1.0,1);
  glVertex3f(-1.25,-1.25,1);
 glEnd;

 glFlush();
 swapBuffers(dc);
 EndPaint(Handle,ps);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity( );

 if width <= height then
  glOrtho (-2, 2, -2*height/width, 2*height/width, 10.0, -10.0)
 else
  glOrtho (-2*width/height, 2*width/height, -2, 2, 10.0, -10.0);


 glViewport(0, 0, width, height);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 wglMakeCurrent(0,0);
 wglDeleteContext(hrc);
 ReleaseDC(handle,DC);
end;

procedure TForm1.PixelFormat;
var
 nPixelFormat:Integer;
 pfd:TPixelFormatDescriptor;
begin
 FillChar(pfd,Sizeof(pfd),0);

 pfd.nSize:=sizeof(pfd);
 pfd.nVersion:=1;
 pfd.dwFlags:=PFD_DOUBLEBUFFER+PFD_SUPPORT_OPENGL+PFD_DRAW_TO_WINDOW;
 pfd.iPixelType:=PFD_TYPE_RGBA;
 pfd.cColorBits:=24;
 pfd.cAlphaBits:=64;
 pfd.cAccumBits:=64;
 pfd.cDepthBits:=32;
 pfd.cStencilBits:=64;
 pfd.iLayerType:=PFD_MAIN_PLANE;

 nPixelFormat:=ChoosePixelFormat(DC,@pfd);
 if nPixelFormat<>0 then
  SetPixelFormat(DC,nPixelFormat,@pfd);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 DC:=GetDC(Handle);
 PixelFormat;
 hrc:=wglCreateContext(DC);
 wglMakeCurrent(DC,hrc);
end;

end.


